package net.minecraft.src;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Map;

public class mod_Nameplate extends BaseMod
{
    public static String itemsPng = "/Nameplate/icons.png";

    public static Item npItem;
    public static Item rlItem;
    public static boolean isForgeEnable = false;
    public static boolean isLMMEnable = false;
    public static boolean isJPInputEnable = false;
    public static int NameplateColor = -1;
    public static int NameplateBkgnd = 0;
    @MLProp(
            name = "ShowDistance"
    )
    public static double ShowDistance = 20.0D;
    @MLProp(
            name = "CraftQuantity"
    )
    public static int CraftQuantity = 4;
    @MLProp(
            name = "Height"
    )
    public static double NameplateHeight = 0.5D;
    @MLProp(
            name = "TextColor"
    )
    public static String strTextColor = "-1";
    @MLProp(
            name = "Background"
    )
    public static String strBkgndColor = "0";
    @MLProp(
            name = "Scale"
    )
    public static double NameplateScale = 1.0D;
    @MLProp(
            name = "ItemID"
    )
    public static int itemID = 27840;
    @MLProp(
            name = "UseResidentsList"
    )
    public static boolean UseResidentsList = false;
    @MLProp(
            name = "ResidentsListItemID"
    )
    public static int ResidentsListItemID = 27841;

    static Class class$EntityNameplate;
    static Class class$EntityNameplateMaid;

    protected static ArrayList<EntityNameplate> NameplateList = new ArrayList<EntityNameplate>();
    protected static World NameplateListCurrentWorld = null;

    public String getVersion()
    {
        return "1.2.5-4";
    }

    public void load()
    {
        try
        {
            if(Class.forName("mod_MinecraftForge") != null)
            {
                System.out.println("MinecraftForge found.");
                isForgeEnable = true;
            }
        }
        catch (Exception var2) { }

        try
        {
            if(Class.forName("mod_littleMaidMob") != null)
            {
                System.out.println("mod:LittleMaidMob found.");
                isLMMEnable = true;
            }
        }
        catch (Exception var2) { }

        try
        {
            if(Class.forName("mod_RequestFocus") != null)
            {
                System.out.println("mod:MinecraftIM found.");
                isJPInputEnable = true;
            }
        }
        catch (Exception var2) { }

        try
        {
            // 文字色の解析
            if (strTextColor.startsWith("0x"))
            {
                strTextColor = "00000000" + strTextColor.substring(2);
                strTextColor = strTextColor.substring(strTextColor.length() - 8);
                NameplateColor = Integer.parseInt(strTextColor.substring(0, 4), 16) << 16 | Integer.parseInt(strTextColor.substring(4, 8), 16);
            }
            else
            {
                NameplateColor = Integer.parseInt(strTextColor);
            }

            // 背景色の解析
            if (strBkgndColor.startsWith("0x"))
            {
                strBkgndColor = "00000000" + strBkgndColor.substring(2);
                strBkgndColor = strBkgndColor.substring(strBkgndColor.length() - 8);
                NameplateBkgnd = Integer.parseInt(strBkgndColor.substring(0, 4), 16) << 16 | Integer.parseInt(strBkgndColor.substring(4, 8), 16);
            }
            else
            {
                NameplateBkgnd = Integer.parseInt(strBkgndColor);
            }
        }
        catch (Exception ex)
        {
            System.out.println("Nameplate:Exception is occurred in load.");
            System.out.println(ex.toString());
        }

        // Entityの登録 {
            ModLoader.registerEntityID(
                class$EntityNameplate == null
                ? (class$EntityNameplate = class$("net.minecraft.src.EntityNameplate"))
                : class$EntityNameplate, "Nameplate", ModLoader.getUniqueEntityId()
            );
            
            if(isLMMEnable)
            {
                ModLoader.registerEntityID(
                    class$EntityNameplateMaid == null
                    ? (class$EntityNameplateMaid = class$("net.minecraft.src.EntityNameplateMaid"))
                    : class$EntityNameplateMaid, "NameplateForMaid", ModLoader.getUniqueEntityId()
                );
            }
        // }
        
        // Itemの登録 {
            ModLoader.addLocalization("item.nameplate.name", "Nameplate");
            ModLoader.addLocalization("item.nameplate.name", "ja_JP", "名札");
            if(isForgeEnable)
            {
                npItem = (new ItemNameplateWithForge(itemID, 0)).setItemName("Nameplate");
                net.minecraft.src.forge.MinecraftForgeClient.preloadTexture(itemsPng);
                //net.minecraft.src.forge.MinecraftForge.registerEntityInteractHandler((ItemNameplate)npItem);
            }
            else
            {
                npItem = (new ItemNameplate(itemID)).setItemName("Nameplate");
                npItem.iconIndex  = ModLoader.addOverride("/gui/items.png", ItemNameplate.texturePng);
            }
            ModLoader.addName(npItem, "Name plate");
            ModLoader.addShapelessRecipe(
                new ItemStack(npItem, CraftQuantity),
                new Object[] {
                    new ItemStack(Item.ingotIron, 1),       // 鉄インゴット
                    new ItemStack(Item.dyePowder, 1, 0),    // イカ墨
                    new ItemStack(Item.silk, 1)             // 糸
                }
            );
        // }
        
        // Itemの登録 {
            if(UseResidentsList)
            {
                ModLoader.addLocalization("item.residentslist.name", "ResitentsList");
                ModLoader.addLocalization("item.residentslist.name", "ja_JP", "名簿");
                if(isForgeEnable)
                {
                    rlItem = (new ItemResidentsListWithForge(ResidentsListItemID, 1)).setItemName("ResitentsList");
                    //net.minecraft.src.forge.MinecraftForgeClient.preloadTexture(itemsPng);
                    //net.minecraft.src.forge.MinecraftForge.registerEntityInteractHandler((ItemNameplate)npItem);
                }
                else
                {
                    rlItem = (new ItemResidentsList(ResidentsListItemID)).setItemName("ResitentsList");
                    rlItem.iconIndex  = ModLoader.addOverride("/gui/items.png", ItemResidentsList.texturePng);
                }
                ModLoader.addName(npItem, "ResitentsList");
                ModLoader.addRecipe(
                    new ItemStack(rlItem, 1),
                    new Object[] {
                        "B", "N", 
                        Character.valueOf('B'), new ItemStack(Item.book, 1),    // 本
                        Character.valueOf('N'), new ItemStack(npItem, 1)        // Nameplate
                    }
                );
            }
        // }
    }

    public void ModsLoaded()
    {
    }

    public void addRenderer(Map mapcls)
    {
        mapcls.put(class$EntityNameplate == null ? (class$EntityNameplate = class$("net.minecraft.src.EntityNameplate")) : class$EntityNameplate, new RenderNameplate());
        if(isLMMEnable)
        {
            mapcls.put(class$EntityNameplateMaid == null ? (class$EntityNameplateMaid = class$("net.minecraft.src.EntityNameplateMaid")) : class$EntityNameplateMaid, new RenderNameplate());
        }
    }

    static Class class$(String var0)
    {
        try
        {
            return Class.forName(var0);
        }
        catch (ClassNotFoundException var2)
        {
            throw new NoClassDefFoundError(var2.getMessage());
        }
    }

    static public void registerEntityNameplate(EntityNameplate nameplate)
    {
        if(NameplateListCurrentWorld != nameplate.worldObj)
        {
            NameplateListCurrentWorld = nameplate.worldObj;
            NameplateList.clear();
        }
        Iterator<EntityNameplate> iterator = NameplateList.listIterator();
        while(iterator.hasNext())
        {
            EntityNameplate var2 = iterator.next();
            // 同じownerを持つNameplateがあった場合は、登録しない
            if(var2.entityOwner == nameplate.entityOwner && ! var2.isDead) return;
        	// 同じownerClass、座標を持つもので、すでにdespawnされたnameplateは除去
        	if(var2.ownerClass == nameplate.ownerClass
        		&& var2.petName == nameplate.petName
        		&& var2.entityOwner.posX == nameplate.entityOwner.posX
        		&& var2.entityOwner.posY == nameplate.entityOwner.posY
        		&& var2.entityOwner.posZ == nameplate.entityOwner.posZ
        		&& ! NameplateListCurrentWorld.loadedEntityList.contains(var2)
        	)
        	{
        		iterator.remove();
        	}
        }
        if(! NameplateList.contains(nameplate))
        {
            NameplateList.add(nameplate);
        }
    }

    // MODが命名できるEntityかどうかを返す
    static boolean EntityNameable(Object entity)
    {
        if(isLMMEnable && entity instanceof EntityLittleMaid)
        {
            if(((EntityLittleMaid)entity).isMaidContract())
            {
                //System.out.println(String.format("Entity %d[%s] is nameable.", new Object[] { ((Entity)entity).entityId, ((Entity)entity).getEntityString() }));
                return true;
            }
        }
        else if(entity instanceof EntityTameable)
        {
            if(((EntityTameable)entity).isTamed())
            {
                //System.out.println(String.format("Entity %d[%s] is nameable.", new Object[] { ((Entity)entity).entityId, ((Entity)entity).getEntityString() }));
                return true;
            }
        }
        else if(entity instanceof EntityLiving)
        {
            try
            {
                Method m = entity.getClass().getMethod("isTamed");
                if(((Boolean)m.invoke(entity, new Object[] {})).booleanValue())
                {
                    //System.out.println(String.format("Entity %d[%s] is nameable.", new Object[] { ((Entity)entity).entityId, ((Entity)entity).getEntityString() }));
                    return true;
                }
            }
            catch(Exception ex) { }
        }
        
        return false;
    }

    // MODの主人・契約主を返却する
    static EntityPlayer getEntityOwner(Entity entity)
    {
        if(isLMMEnable && entity instanceof EntityLittleMaid)
        {
            if(((EntityLittleMaid)entity).isMaidContract())
            {
                return ((EntityLittleMaid)entity).getMaidMasterEntity();
            }
        }
        else if(entity instanceof EntityTameable)
        {
            if(((EntityTameable)entity).isTamed())
            {
                EntityLiving owner = ((EntityTameable)entity).getOwner();
                if(owner instanceof EntityPlayer) return (EntityPlayer)owner;
                return null;
            }
        }
        else if(entity instanceof EntityLiving)
        {
            try
            {
                Method m = entity.getClass().getMethod("getOwner");
                Entity owner = (Entity)(m.invoke(entity, new Object[] {}));
                if(owner instanceof EntityPlayer) return (EntityPlayer)owner;
                return null;
            }
            catch(Exception ex) { }
        }
        
        return null;
    }

    // MODの主人・契約主にチャットメッセージを表示する
    static void addChatMessageToEntityOwner(Entity entity, String message)
    {
        EntityPlayer owner = getEntityOwner(entity);
        if(owner == null) return;
        
        // アイテムを持っているか調査
        if(! owner.inventory.hasItemStack(new ItemStack(rlItem, 1)))
        {
            //System.out.println("Owner does not have ResidentsList");
            return;
        }
        
        // メッセージを表示
        owner.addChatMessage(message);
    }
}
